## openturns 1.24

=== CMakeLists.txt ===
#                                               -*- cmake -*-

cmake_minimum_required (VERSION 3.13)

# By default, build in Release mode. Must appear before project() command
set(CMAKE_BUILD_TYPE Release CACHE STRING "Build type")
set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "" Release Debug RelWithDebInfo MinSizeRel)
set (CMAKE_TRY_COMPILE_CONFIGURATION ${CMAKE_BUILD_TYPE})

project (openturns)

option (USE_BISON                    "Looks for Bison if true and then build parser"                         ON)
option (USE_CUBA                     "Use Cuba library"                                                      ON)
option (USE_FLEX                     "Looks for Flex if true and then build lexer"                           ON)
option (USE_TBB                      "Use Intel Threading Building Blocks library for multithreading"        ON)
option (USE_HMAT                     "Use HMat library (enforces GPL license)"                               OFF)
option (USE_MUPARSER                 "Use muParser library"                                                  ON)
option (USE_EXPRTK                   "Use ExprTK library"                                                    ON)
option (USE_LIBXML2                  "Use LibXml2 for XML support"                                           ON)
option (USE_HDF5                     "Use HDF5 for high volume storage"                                      ON)
option (USE_BOOST                    "Use Boost for distribution computation"                                ON)
option (USE_MPFR                     "Use MPFR for real valued special functions computation"                ON)
option (USE_MPC                      "Use MPC for complex valued special functions computation"              ON)
option (USE_SPHINX                   "Use sphinx for documentation"                                          OFF)
option (USE_DOXYGEN                  "Use Doxygen for API documentation"                                     ON)
option (USE_NLOPT                    "Use NLopt for additional optimization algorithms"                      ON)
option (USE_CERES                    "Use Ceres Solver for additional optimization algorithms"               ON)
option (USE_CMINPACK                 "Use CMinpack for additional optimization algorithms"                   ON)
option (USE_DLIB                     "Use dlib for additional optimization algorithms"                       ON)
option (USE_IPOPT                    "Use Ipopt for nonlinear optimization"                                  ON)
option (USE_BONMIN                   "Use Bonmin for MINLP problems"                                         ON)
option (USE_PAGMO                    "Use Pagmo for multi-objective optimization"                            ON)
option (USE_SPECTRA                  "Use Spectra for eigenvalues computation"                               ON)
option (USE_PRIMESIEVE               "Use primesieve for prime numbers generation"                           ON)
option (USE_OPENMP                   "Use OpenMP to disable threading"                                       ON)
option (USE_OPENBLAS                 "Use OpenBLAS to disable threading"                                     ON)
option (USE_CXX17                    "Use C++17 standard"                                                    ON)
option (USE_NANOFLANN                "Use nanoflann for Nearest Neighbor search"                             ON)

option (BUILD_PYTHON                 "Build the python module for the library"                               ON)
option (BUILD_SHARED_LIBS            "Build shared libraries"                                                ON)

# Defines our own module path
list (APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

if (POLICY CMP0022)
  # INTERFACE_LINK_LIBRARIES defines the link interface
  cmake_policy (SET CMP0022 NEW)
endif()

if (POLICY CMP0057)
  # Support new IN_LIST if() operator
  cmake_policy (SET CMP0057 NEW)
endif ()

if (POLICY CMP0068)
  # RPATH settings on macOS do not affect install_name
  cmake_policy (SET CMP0068 NEW)
endif ()

if (POLICY CMP0093)
  # FindBoost reports Boost_VERSION in x.y.z format
  cmake_policy (SET CMP0093 NEW)
endif ()

if (POLICY CMP0058)
  # Ninja requires custom command byproducts to be explicit
  cmake_policy (SET CMP0058 NEW)
endif()

if(POLICY CMP0042)
  # Set MACOSX_RPATH to ON
  cmake_policy(SET CMP0042 NEW)
endif()

if (POLICY CMP0054)
  cmake_policy (SET CMP0054 NEW)
endif ()

if (POLICY CMP0056)
  cmake_policy (SET CMP0056 NEW)
endif ()

if (POLICY CMP0066)
  cmake_policy (SET CMP0066 NEW)
endif ()

if (POLICY CMP0074)
  # find_package() uses <PackageName>_ROOT variables
  cmake_policy(SET CMP0074 NEW)
endif ()

if (POLICY CMP0078)
  # swig standard target names
  cmake_policy(SET CMP0078 NEW)
endif ()

if (POLICY CMP0086)
  # UseSWIG honors SWIG_MODULE_NAME via -module flag
  cmake_policy(SET CMP0086 NEW)
endif ()

set (OPENTURNS_HOME_ENV_VAR OPENTURNS_HOME)

include (GNUInstallDirs)

set (OPENTURNS_LIBRARY_PATH ${CMAKE_INSTALL_LIBDIR} CACHE PATH "The directory where the library is installed")
set (OPENTURNS_BIN_PATH ${CMAKE_INSTALL_BINDIR} CACHE PATH "Binary install path")
set (OPENTURNS_INCLUDE_PATH ${CMAKE_INSTALL_INCLUDEDIR} CACHE PATH "The directory where the header files are installed")
set (OPENTURNS_CONFIG_CMAKE_PATH ${CMAKE_INSTALL_LIBDIR}/cmake/openturns CACHE PATH "The directory where the CMake files are installed")
set (OPENTURNS_SYSCONFIG_PATH ${CMAKE_INSTALL_SYSCONFDIR} CACHE PATH "The directory where the configuration file is installed")
set (OPENTURNS_DATA_PATH ${CMAKE_INSTALL_DATAROOTDIR} CACHE PATH "The directory where the common files are installed")
set (OPENTURNS_DOC_PATH ${CMAKE_INSTALL_DOCDIR} CACHE PATH "The directory where the license files are installed")

if (WIN32)
  set (DEFAULT_TMP TEMP)
  set (PATH_SEP "\\;")
else ()
  set(DEFAULT_TMP /tmp)
  set (PATH_SEP ":")
endif()

set (OPENTURNS_TEMPDIR
      ${DEFAULT_TMP}
      CACHE PATH "The directory for temporary files. /tmp by default."
   )
set (TEMPDIR ${OPENTURNS_TEMPDIR})

if (NOT DEFINED LAPACK_LIBRARIES)
  find_package (LAPACK REQUIRED)
endif ()
list (APPEND OPENTURNS_PRIVATE_LIBRARIES ${LAPACK_LIBRARIES})

if (USE_SPECTRA)
  find_package (Spectra 1.0 CONFIG)
endif ()
if (Spectra_FOUND)
  message(STATUS "Found Spectra: ${Spectra_DIR} (found suitable version \"${Spectra_VERSION}\")")
  set (OPENTURNS_HAVE_SPECTRA TRUE)
  list (APPEND OPENTURNS_PRIVATE_LIBRARIES Spectra::Spectra)
  list (APPEND OPENTURNS_ENABLED_FEATURES "spectra")
  if (NOT TARGET Eigen3::Eigen)
    find_package (Eigen3 CONFIG)
  endif ()
endif()

if (USE_PRIMESIEVE)
  find_package (primesieve CONFIG)
  if (primesieve_FOUND)
    set (OPENTURNS_HAVE_PRIMESIEVE TRUE)
    message (STATUS "Found primesieve: ${primesieve_DIR} (found version ${primesieve_VERSION})")
    list (APPEND OPENTURNS_PRIVATE_LIBRARIES primesieve::primesieve)
    list (APPEND OPENTURNS_ENABLED_FEATURES "primesieve")
  else ()
    # fallback to our macro if primesieveConfig is not provided
    find_package (primesieve)
    if (primesieve_FOUND)
      set (OPENTURNS_HAVE_PRIMESIEVE TRUE)
      list (APPEND OPENTURNS_PRIVATE_INCLUDE_DIRS ${PRIMESIEVE_INCLUDE_DIRS})
      list (APPEND OPENTURNS_PRIVATE_LIBRARIES ${PRIMESIEVE_LIBRARIES})
      list (APPEND OPENTURNS_ENABLED_FEATURES "primesieve")
    endif ()
  endif ()
endif ()

if (USE_BISON)
  find_package (BISON 2.4)
  if (BISON_FOUND)
    set (OPENTURNS_HAVE_BISON TRUE)
  endif ()
endif ()

if (USE_FLEX)
  find_package (FLEX)
  if (FLEX_FOUND)
    set (OPENTURNS_HAVE_FLEX TRUE)
  endif ()
endif ()

if (BISON_FOUND AND FLEX_FOUND)
  list (APPEND OPENTURNS_ENABLED_FEATURES "bison")
endif ()

if (USE_TBB)
  find_package (TBB CONFIG)
  if (TBB_FOUND)
    message (STATUS "Found TBB: ${TBB_DIR} (found version ${TBB_VERSION})")
    set (TBB_LIBRARIES TBB::tbb)
  else ()
    # fallback to our macro
    find_package (TBB 2017)
  endif ()
endif ()
if (TBB_FOUND)
  set (OPENTURNS_HAVE_TBB TRUE)
  if (TBB_INCLUDE_DIRS)
    list (APPEND OPENTURNS_PRIVATE_INCLUDE_DIRS ${TBB_INCLUDE_DIRS})
  endif ()
  list (APPEND OPENTURNS_PRIVATE_LIBRARIES ${TBB_LIBRARIES})
  if (MSVC OR WINTEL)
    set (OPENTURNS_TBB_NO_IMPLICIT_LINKAGE ON CACHE BOOL "Prevent implicit linkage against tbb.lib ")
  endif ()
  list (APPEND OPENTURNS_ENABLED_FEATURES "tbb")
endif ()

if (USE_MUPARSER)
  find_package (muParser 2.2.3 QUIET)
endif ()
if (MUPARSER_FOUND)
  set (OPENTURNS_HAVE_MUPARSER TRUE)
  set (OPENTURNS_HAVE_ANALYTICAL_PARSER TRUE)
  list (APPEND OPENTURNS_PRIVATE_LIBRARIES ${MUPARSER_LIBRARIES})
  list (APPEND OPENTURNS_PRIVATE_INCLUDE_DIRS ${MUPARSER_INCLUDE_DIRS})
  list (APPEND OPENTURNS_ENABLED_FEATURES "muparser")
  set (SYMBOLICPARSER_DEFAULT_BACKEND MuParser)
endif ()
if (USE_EXPRTK)
  set (OPENTURNS_HAVE_EXPRTK TRUE)
  set (OPENTURNS_HAVE_ANALYTICAL_PARSER TRUE)
  set (SYMBOLICPARSER_DEFAULT_BACKEND ExprTk)
endif ()

if (USE_HMAT)
  find_package (HMAT 1.7 CONFIG)
endif ()
if (HMAT_FOUND)
  message(STATUS "Found HMAT: ${HMAT_DIR} (found suitable version \"${HMAT_VERSION}\")")
  set (OPENTURNS_HAVE_HMAT TRUE)
  list (APPEND OPENTURNS_PRIVATE_INCLUDE_DIRS ${HMAT_INCLUDE_DIRS})
  list (APPEND OPENTURNS_PRIVATE_LIBRARIES ${HMAT_LIBRARIES})
  list (APPEND OPENTURNS_ENABLED_FEATURES "hmat")
endif ()

if (USE_DOXYGEN)
  find_package (Doxygen QUIET)
endif ()

if (USE_LIBXML2)
  find_package (LibXml2)
endif ()
if (LibXml2_FOUND)
  set (OPENTURNS_HAVE_LIBXML2 TRUE)
  list (APPEND OPENTURNS_PRIVATE_LIBRARIES LibXml2::LibXml2)
  list (APPEND OPENTURNS_ENABLED_FEATURES "libxml2")
endif ()

if (USE_HDF5)
  find_package(HDF5 COMPONENTS C CXX)
endif ()
if (HDF5_FOUND)
  set (OPENTURNS_HAVE_HDF5 TRUE)
  list (APPEND OPENTURNS_DEFINITIONS ${HDF5_DEFINITIONS})
  list (APPEND OPENTURNS_PRIVATE_INCLUDE_DIRS ${HDF5_INCLUDE_DIRS})
  list (APPEND OPENTURNS_PRIVATE_LIBRARIES ${HDF5_LIBRARIES})
  list (APPEND OPENTURNS_ENABLED_FEATURES "hdf5")
endif ()

if (USE_BOOST)
  find_package (Boost CONFIG 1.46)
  if (Boost_FOUND)
    message(STATUS "Found Boost: ${Boost_DIR} (found suitable version \"${Boost_VERSION}\")")
  endif ()

  # fallback to FindBoost before its deprecation
  if (CMAKE_VERSION VERSION_LESS 3.30 AND NOT Boost_FOUND)
    find_package (Boost MODULE 1.46)
  endif ()

  if (Boost_FOUND)
    if (CMAKE_VERSION VERSION_LESS 3.15)
      # Boost_VERSION reports the integer BOOST_VERSION from boost/version.hpp instead of x.y.z format
      set (Boost_VERSION "${Boost_MAJOR_VERSION}.${Boost_MINOR_VERSION}.${Boost_SUBMINOR_VERSION}")
    endif ()
    set (OPENTURNS_HAVE_BOOST TRUE)
    if (USE_MPFR)
      find_package (MPFR)
      if (MPFR_FOUND)
        set (OPENTURNS_HAVE_MPFR TRUE)
        list (APPEND OPENTURNS_PRIVATE_INCLUDE_DIRS ${MPFR_INCLUDE_DIRS})
        list (APPEND OPENTURNS_PRIVATE_LIBRARIES ${MPFR_LIBRARIES})
        list (APPEND OPENTURNS_ENABLED_FEATURES "mpfr")
      endif ()
    endif ()
    if (USE_MPC AND NOT Boost_VERSION VERSION_LESS 1.68)
      find_package (MPC)
      if (MPC_FOUND)
        set (OPENTURNS_HAVE_MPC TRUE)
        list (APPEND OPENTURNS_PRIVATE_INCLUDE_DIRS ${MPC_INCLUDE_DIRS})
        list (APPEND OPENTURNS_PRIVATE_LIBRARIES ${MPC_LIBRARIES})
        list (APPEND OPENTURNS_ENABLED_FEATURES "mpc")
      endif ()
    endif ()
    list (APPEND OPENTURNS_PRIVATE_LIBRARIES Boost::boost)
    list (APPEND OPENTURNS_ENABLED_FEATURES "boost")
  endif ()
endif ()

if (USE_CUBA)
  find_package (Cuba)
  if (Cuba_FOUND)
    set (OPENTURNS_HAVE_CUBA TRUE)
    list (APPEND OPENTURNS_PRIVATE_INCLUDE_DIRS ${CUBA_INCLUDE_DIRS})
    list (APPEND OPENTURNS_PRIVATE_LIBRARIES ${CUBA_LIBRARIES})
    list (APPEND OPENTURNS_ENABLED_FEATURES "cuba")
  endif ()
endif ()

if (USE_NLOPT)
  find_package (NLopt 2.6 CONFIG)
  if (NLopt_FOUND)
    message(STATUS "Found NLopt: ${NLopt_DIR}  (found version \"${NLopt_VERSION}\")")
    set (OPENTURNS_HAVE_NLOPT TRUE)

=== lib/etc/CMakeLists.txt ===
#                                               -*- cmake -*-

configure_file (${CMAKE_CURRENT_SOURCE_DIR}/openturns.conf.in
                 ${CMAKE_CURRENT_BINARY_DIR}/openturns.conf
                 @ONLY)

install (FILES ${CMAKE_CURRENT_BINARY_DIR}/openturns.conf
          DESTINATION ${OPENTURNS_SYSCONFIG_PATH}/openturns
       )

=== lib/src/CMakeLists.txt ===
#                                               -*- cmake -*-

# Register current directory files
ot_add_current_dir_to_include_dirs ()
ot_install_header_file (OT.hxx)

# Recurse in subdirectories
add_subdirectory (Base)
add_subdirectory (Uncertainty)

set_source_files_properties (Base/Func/SpecFunc/Faddeeva.cc PROPERTIES SKIP_UNITY_BUILD_INCLUSION ON)

# Exclude Ceres sources from unity build (templates take much memory)
if (Ceres_FOUND)
  set_source_files_properties (Base/Optim/Ceres.cxx PROPERTIES SKIP_UNITY_BUILD_INCLUSION ON)
endif ()

# Exclude Dlib sources from unity build (Lapack re-included)
if (dlib_FOUND)
  set_source_files_properties (Base/Optim/Dlib.cxx Base/Optim/DlibFunctions.cxx PROPERTIES SKIP_UNITY_BUILD_INCLUSION ON)
endif ()

# Exclude Ipopt sources
if (Ipopt_FOUND)
  set_source_files_properties (Base/Optim/Ipopt.cxx Base/Optim/IpoptProblem.cxx PROPERTIES SKIP_UNITY_BUILD_INCLUSION ON)
endif ()

# Exclude Bonmin sources
if (Bonmin_FOUND)
  set_source_files_properties (Base/Optim/Bonmin.cxx Base/Optim/BonminProblem.cxx PROPERTIES SKIP_UNITY_BUILD_INCLUSION ON)
  if (CMAKE_CXX_COMPILER_ID MATCHES "GNU")
    if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 7)
      set_source_files_properties (Base/Optim/Bonmin.cxx Base/Optim/BonminProblem.cxx PROPERTIES COMPILE_FLAGS "-Wno-error=unused-parameter")
    else ()
      set_source_files_properties (Base/Optim/Bonmin.cxx Base/Optim/BonminProblem.cxx PROPERTIES COMPILE_FLAGS "-Wno-error=unused-parameter -Wno-error=implicit-fallthrough -Wno-error=overloaded-virtual")
    endif ()
  endif ()
endif ()

if (Pagmo_FOUND)
  set_source_files_properties (Base/Optim/Pagmo.cxx PROPERTIES SKIP_UNITY_BUILD_INCLUSION ON)
endif ()

# Exclude LibXML sources
if (LIBXML2_FOUND)
  set_source_files_properties (Base/Common/XMLStorageManager.cxx Base/Common/XMLToolbox.cxx PROPERTIES SKIP_UNITY_BUILD_INCLUSION ON)
endif ()

# Exclude HDF5 sources
if (LIBXML2_FOUND AND HDF5_FOUND)
  set_source_files_properties (Base/Common/XMLH5StorageManager.cxx PROPERTIES SKIP_UNITY_BUILD_INCLUSION ON)
endif ()

# Exclude HMAT sources
if (HMAT_FOUND)
  set_source_files_properties (Base/Stat/HMatrixFactory.cxx Base/Stat/HMatrixImplementation.cxx PROPERTIES SKIP_UNITY_BUILD_INCLUSION ON)
endif ()

if (nanoflann_FOUND)
  set_source_files_properties (Base/Algo/KDTree.cxx PROPERTIES SKIP_UNITY_BUILD_INCLUSION ON)
endif ()

# SymbolicParserExprTk.cxx includes exprtk.hpp which is huge, exclude it from unity builds
# It also causes problems on Windows
if (OPENTURNS_HAVE_EXPRTK)
  set_source_files_properties ("Base/Func/SymbolicParserExprTk.cxx" PROPERTIES SKIP_UNITY_BUILD_INCLUSION ON)
  if (MINGW)
    set_source_files_properties ("Base/Func/SymbolicParserExprTk.cxx" PROPERTIES COMPILE_FLAGS "-Wa,-mbig-obj -g0")
  endif ()
endif()

# Exclude spectra sources from unity build (templates take a lot of memory)
if (Spectra_FOUND)
  set_source_files_properties (Base/Algo/KarhunenLoeveP1Algorithm.cxx PROPERTIES SKIP_UNITY_BUILD_INCLUSION ON)
endif ()

# Exclude cuba sources
if (Cuba_FOUND)
  set_source_files_properties (Base/Algo/CubaIntegration.cxx PROPERTIES SKIP_UNITY_BUILD_INCLUSION ON)
endif ()

# Build main library
foreach (built_source ${BUILT_SOURCEFILES})
  set_source_files_properties (${built_source} PROPERTIES GENERATED TRUE)
endforeach (built_source)
include_directories (BEFORE ${INTERNAL_INCLUDE_DIRS})
add_library (OT ${SOURCEFILES} ${BUILT_SOURCEFILES} ${HEADERFILES})
set_target_properties (OT PROPERTIES POSITION_INDEPENDENT_CODE ON)

target_compile_definitions(OT PRIVATE ${OPENTURNS_DEFINITIONS})
if (NOT BUILD_SHARED_LIBS)
  target_compile_definitions (OT PUBLIC "OT_STATIC")
endif ()

# soversion
set_target_properties (OT PROPERTIES SOVERSION 0.25)
set (LIB_VERSION 0.25.0)
set_target_properties (OT PROPERTIES VERSION ${LIB_VERSION})

if (BISON_FOUND AND FLEX_FOUND)
  add_dependencies (OT generate_csv_lexer)
  add_dependencies (OT generate_csv_parser)
endif ()

target_link_libraries (OT PRIVATE ${OPENTURNS_PRIVATE_LIBRARIES})

target_include_directories (OT INTERFACE $<INSTALL_INTERFACE:include>)
target_include_directories (OT PUBLIC ${OPENTURNS_INCLUDE_DIRS})

if (USE_CXX17)
  set_property (TARGET OT PROPERTY CXX_STANDARD 17)
  target_compile_definitions (OT PRIVATE OPENTURNS_ENABLE_CXX17)

  if (CMAKE_CXX_COMPILER_ID MATCHES "GNU" AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 9.1)
    target_link_libraries (OT PRIVATE stdc++fs)
  endif ()
else ()
  set_property (TARGET OT PROPERTY CXX_STANDARD 11)
endif ()
target_compile_features (OT PUBLIC cxx_std_11)

set_property (TARGET OT PROPERTY OPENTURNS_ENABLED_FEATURES "${OPENTURNS_ENABLED_FEATURES}")
set_property (TARGET OT APPEND PROPERTY EXPORT_PROPERTIES "OPENTURNS_ENABLED_FEATURES")

# Add targets to the build-tree export set
export(TARGETS OT FILE "${PROJECT_BINARY_DIR}/OpenTURNS-Targets.cmake")

# Install the export set for use with the install-tree
install(EXPORT OpenTURNS-Targets DESTINATION ${OPENTURNS_CONFIG_CMAKE_PATH} COMPONENT Development)

# Install rules for library and executable
install (TARGETS OT
          EXPORT  OpenTURNS-Targets
          RUNTIME DESTINATION ${OPENTURNS_BIN_PATH}
          LIBRARY DESTINATION ${OPENTURNS_LIBRARY_PATH}
          ARCHIVE DESTINATION ${OPENTURNS_LIBRARY_PATH})

if (UNIX AND BUILD_SHARED_LIBS)
  set (OT_GDB_PY ${CMAKE_SHARED_LIBRARY_PREFIX}OT${CMAKE_SHARED_LIBRARY_SUFFIX}.${LIB_VERSION}-gdb.py)
  execute_process (COMMAND ${CMAKE_COMMAND} -E create_symlink ${CMAKE_CURRENT_SOURCE_DIR}/libOT-gdb.py ${CMAKE_CURRENT_BINARY_DIR}/${OT_GDB_PY})
  install (FILES libOT-gdb.py DESTINATION ${OPENTURNS_DATA_PATH}/gdb/auto-load${LIBRARY_PATH} RENAME ${OT_GDB_PY})
endif ()

=== lib/test/CMakeLists.txt ===
#                                               -*- cmake -*-
#
#  CMakeLists.txt
#
#  Copyright 2005-2024 Airbus-EDF-IMACS-ONERA-Phimeca
#
#  This library is free software: you can redistribute it and/or modify
#  it under the terms of the GNU Lesser General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public License
#  along with this library.  If not, see <http://www.gnu.org/licenses/>.
#
#

if (MINGW AND CMAKE_SIZEOF_VOID_P EQUAL 4)
  add_library (CRT_fp8 STATIC EXCLUDE_FROM_ALL CRT_fp8.c)
endif ()

set (CHECK_ENVIRONMENT "OPENTURNS_CONFIG_PATH=${PROJECT_BINARY_DIR}/lib/etc")

# This macro compiles and runs a C++ test
set (CHECK_TO_BE_RUN)
macro (ot_check_test TESTNAME)
  set (TEST_TARGET t_${TESTNAME})
  add_executable (${TEST_TARGET} EXCLUDE_FROM_ALL ${TEST_TARGET}.cxx)
  add_dependencies(tests ${TEST_TARGET})
  target_include_directories(${TEST_TARGET} PRIVATE ${INTERNAL_INCLUDE_DIRS} BEFORE)
  target_link_libraries (${TEST_TARGET} PRIVATE OT)
  if (MINGW AND CMAKE_SIZEOF_VOID_P EQUAL 4)
    target_link_libraries (${TEST_TARGET} PRIVATE CRT_fp8)
  endif ()
  set_target_properties (${TEST_TARGET} PROPERTIES
                         UNITY_BUILD OFF
                         INSTALL_RPATH "${PROJECT_BINARY_DIR}/lib/src;${CMAKE_INSTALL_RPATH}")
  set (_IGNOREOUT OFF)
  foreach (_ARG ${ARGN})
    if (${_ARG} MATCHES IGNOREOUT)
      set (_IGNOREOUT ON)
    endif ()
  endforeach ()

  if (_IGNOREOUT)
    add_test (NAME cppcheck_${TESTNAME} COMMAND ${TEST_TARGET})
  else ()
    set (OUTFILE_LOC ${CMAKE_CURRENT_SOURCE_DIR}/${TEST_TARGET}.expout)
    if (NOT EXISTS ${OUTFILE_LOC})
      message (SEND_ERROR "Missing file ${OUTFILE_LOC}")
    endif ()
    add_test (NAME cppcheck_${TESTNAME} COMMAND "sh" "-c" "(${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:${TEST_TARGET}> > ${CMAKE_CURRENT_BINARY_DIR}/${TEST_TARGET}.out) && diff -u --strip-trailing-cr ${OUTFILE_LOC} ${CMAKE_CURRENT_BINARY_DIR}/${TEST_TARGET}.out")
  endif ()
  set_tests_properties (cppcheck_${TESTNAME} PROPERTIES ENVIRONMENT "${CHECK_ENVIRONMENT}")
  list (APPEND CHECK_TO_BE_RUN ${TEST_TARGET})
endmacro ()


# Common
ot_check_test (Object_std)
ot_check_test (OStream_std)
ot_check_test (PersistentObject_std)
ot_check_test (Pointer_std)
ot_check_test (Pointer_cast)
ot_check_test (Exception_std IGNOREOUT)
ot_check_test (Log_std)
find_package (Threads)
target_link_libraries (t_Log_std PRIVATE ${CMAKE_THREAD_LIBS_INIT})
ot_check_test (IdFactory_std IGNOREOUT)
ot_check_test (ComparisonOperator_std)
if (LIBXML2_FOUND)
  ot_check_test (Study_saveload)
  if (HDF5_FOUND)
    ot_check_test (Study_h5)
  endif ()
endif ()
ot_check_test (ResourceMap_std IGNOREOUT)
ot_check_test (Catalog_std IGNOREOUT)
ot_check_test (AtomicInt_std IGNOREOUT)
target_link_libraries (t_AtomicInt_std PRIVATE ${CMAKE_THREAD_LIBS_INIT})

# Type
ot_check_test (BipartiteGraph_std)
ot_check_test (Collection_std)
ot_check_test (Indices_std)
ot_check_test (IndicesCollection_std)
ot_check_test (Description_std)
ot_check_test (Point_std)
ot_check_test (Point_description)
ot_check_test (Matrix_std)
ot_check_test (SparseMatrix_std)
ot_check_test (IdentityMatrix_std)
ot_check_test (Tensor_std)
ot_check_test (ComplexTensor_std)
ot_check_test (SymmetricTensor_std)
ot_check_test (SquareMatrix_std)
ot_check_test (TriangularMatrix_std)
ot_check_test (SymmetricMatrix_std)
ot_check_test (Matrix_solve)
ot_check_test (Matrix_decomposition)
ot_check_test (SquareMatrix_lapack)
ot_check_test (SymmetricMatrix_lapack)
ot_check_test (Cache_std)
ot_check_test (ComplexMatrix_std)
ot_check_test (SquareComplexMatrix_std)
ot_check_test (HermitianMatrix_std)
ot_check_test (TriangularComplexMatrix_std)

# Func
ot_check_test (LinearEvaluation_std)
ot_check_test (ConstantGradient_std)
ot_check_test (AggregatedEvaluation_std)
ot_check_test (PiecewiseLinearEvaluation_std)
ot_check_test (PiecewiseHermiteEvaluation_std)
ot_check_test (P1LagrangeEvaluation_std)
if (OPENTURNS_HAVE_EXPRTK)
ot_check_test (SymbolicEvaluation_std)
ot_check_test (SymbolicGradient_std)
ot_check_test (SymbolicHessian_std)
ot_check_test (SymbolicFunction_std)
endif ()
if (OPENTURNS_HAVE_MUPARSER)
ot_check_test (SymbolicEvaluation_muparser)
ot_check_test (SymbolicGradient_muparser)
ot_check_test (SymbolicHessian_muparser)
ot_check_test (SymbolicFunction_muparser)
endif ()
ot_check_test (TranslationFunction_std)
ot_check_test (LinearFunction_std)
ot_check_test (LinearCombinationEvaluation_std)
ot_check_test (LinearCombinationGradient_std)
ot_check_test (LinearCombinationHessian_std)
ot_check_test (QuadraticEvaluation_std)
ot_check_test (LinearGradient_std)
ot_check_test (ConstantHessian_std)
ot_check_test (MethodBoundEvaluation_std)
ot_check_test (IndicatorFunction_std IGNOREOUT)
ot_check_test (DistanceToDomainFunction_std IGNOREOUT)
ot_check_test (AggregatedFunction_std)
ot_check_test (DualLinearCombinationFunction_std)
ot_check_test (LinearCombinationFunction_std)
ot_check_test (Function_operations)
ot_check_test (ParametricFunction_std)
ot_check_test (DatabaseFunction_std)
ot_check_test (MemoizeFunction_std)

ot_check_test (Function_draw)
ot_check_test (MonomialFunction_std)
ot_check_test (MonomialFunctionFactory_std)
ot_check_test (TensorizedUniVariateFunctionFactory_std)

ot_check_test (UniVariatePolynomial_std)
ot_check_test (Basis_std)
ot_check_test (BasisSequence_std)
ot_check_test (LARS_std)
ot_check_test (FieldFunction_std)
ot_check_test (FieldToPointFunction_std)
ot_check_test (PointToFieldFunction_std)
ot_check_test (ValueFunction_std)
ot_check_test (VertexValueFunction_std)
ot_check_test (PointToPointEvaluation_std)
ot_check_test (PointToPointConnection_std)
ot_check_test (PointToFieldConnection_std)
ot_check_test (FieldToPointConnection_std)
ot_check_test (FieldToFieldConnection_std)
ot_check_test (BoxCoxEvaluation_std)
ot_check_test (BoxCoxTransform_std)
ot_check_test (InverseBoxCoxEvaluation_std)
ot_check_test (InverseBoxCoxTransform_std)
ot_check_test (TrendEvaluation_std)
ot_check_test (TrendTransform_std)
ot_check_test (InverseTrendEvaluation_std)
ot_check_test (InverseTrendTransform_std)
ot_check_test (ExpertMixture_std)
ot_check_test (BasisFactory_std)

# Optim
ot_check_test (AbdoRackwitz_std)
if (Ceres_FOUND)
ot_check_test (Ceres_std)
endif ()
if (CMinpack_FOUND)
ot_check_test (CMinpack_std)
endif ()
ot_check_test (Cobyla_std)
if (dlib_FOUND)
  ot_check_test (Dlib_std IGNOREOUT)
  ot_check_test (Dlib_global IGNOREOUT)
endif()
if (Bonmin_FOUND)
  ot_check_test (Bonmin_std IGNOREOUT)
endif()

ot_check_test (SQP_std)
ot_check_test (TNC_std)
ot_check_test (NearestPointChecker_std)
if (NLopt_FOUND)
  ot_check_test (NLopt_std IGNOREOUT)
endif ()
ot_check_test (MultiStart_std IGNOREOUT)

# Solver
ot_check_test (Bisection_std)
ot_check_test (Brent_std)
ot_check_test (Secant_std)
ot_check_test (RungeKutta_std)
ot_check_test (Fehlberg_std)

# Stat
ot_check_test (Sample_std)
ot_check_test (Sample_split)
ot_check_test (Sample_large)
ot_check_test (Sample_computation)
ot_check_test (Sample_operators)
ot_check_test (HistoryStrategy_std)
ot_check_test (CovarianceMatrix_std)
ot_check_test (CorrelationMatrix_std)
ot_check_test (TestResult_std)
ot_check_test (Field_draw)
ot_check_test (Field_std)
ot_check_test (ProcessSample_std)
ot_check_test (RandomGenerator_std)
ot_check_test (SobolSequence_std IGNOREOUT)
ot_check_test (FaureSequence_std IGNOREOUT)
ot_check_test (HaltonSequence_std IGNOREOUT)
ot_check_test (HaselgroveSequence_std)
ot_check_test (ReverseHaltonSequence_std)
ot_check_test (CorrelationAnalysis_std IGNOREOUT)
ot_check_test (TimeSeries_std)
ot_check_test (FilteringWindows_std)
ot_check_test (WelchFactory_std)
ot_check_test (ExponentialModel_std)
ot_check_test (CovarianceModel_std IGNOREOUT)
ot_check_test (DiracCovarianceModel_std)
ot_check_test (ExponentiallyDampedCosineModel_std)
ot_check_test (CauchyModel_std)
ot_check_test (UserDefinedSpectralModel_std)
ot_check_test (UserDefinedCovarianceModel_std)
ot_check_test (UserDefinedStationaryCovarianceModel_std)
ot_check_test (StationaryCovarianceModelFactory_std)
ot_check_test (NonStationaryCovarianceModelFactory_std)
ot_check_test (LatentVariableModel_std IGNOREOUT)
if (HMAT_FOUND)
ot_check_test (HMatrix_LDLt)
ot_check_test (HMatrix_LLt)
ot_check_test (HMatrix_LU)
ot_check_test (HMatrix_block_LLt)
ot_check_test (HMatrix_block_LU)
ot_check_test (DiracCovarianceModel_hmat)
endif ()

# Diff
ot_check_test (FiniteDifferenceStep_std)

# Geom
ot_check_test (Domain_std)
ot_check_test (Interval_std)
ot_check_test (IntervalMesher_std)
ot_check_test (LevelSet_std)
ot_check_test (LevelSetMesher_std)
ot_check_test (Mesh_std)
ot_check_test (Mesh_draw)
ot_check_test (RegularGrid_std)
ot_check_test (DomainComplement_std)
ot_check_test (DomainDifference_std)
ot_check_test (DomainIntersection_std)
ot_check_test (DomainUnion_std)
ot_check_test (DomainDisjunctiveUnion_std)

# Graph
ot_check_test (BarPlot_std)
ot_check_test (Cloud_std)
ot_check_test (Contour_std)
ot_check_test (Curve_std)
ot_check_test (Drawable_std)
ot_check_test (Graph_mix)
ot_check_test (Pie_std)
ot_check_test (Polygon_std)
ot_check_test (PolygonArray_std)
ot_check_test (Staircase_std)
ot_check_test (Text_std)

# Algo
ot_check_test (PenalizedLeastSquaresAlgorithm_std)
ot_check_test (CorrectedLeaveOneOut_std)
ot_check_test (KDTree_std)
ot_check_test (RegularGridNearestNeighbour_std)
ot_check_test (NaiveNearestNeighbour_std)
ot_check_test (NearestNeighbour1D_std)
ot_check_test (BoundingVolumeHierarchy_std)
ot_check_test (NaiveEnclosingSimplex_std)
ot_check_test (RegularGridEnclosingSimplex_std IGNOREOUT)
ot_check_test (EnclosingSimplexMonotonic1D_std IGNOREOUT)
ot_check_test (KFold_std)
ot_check_test (LeastSquaresMetaModelSelectionFactory_std)
ot_check_test (KissFFT_std)
ot_check_test (FilonQuadrature_std)
if (Cuba_FOUND)
  ot_check_test (CubaIntegration_std IGNOREOUT)
endif ()
ot_check_test (GaussKronrod_std)
ot_check_test (GaussLegendre_std)
ot_check_test (FejerAlgorithm_std IGNOREOUT)
ot_check_test (IteratedQuadrature_std)
ot_check_test (KarhunenLoeveP1Algorithm_std)
if (OPENTURNS_HAVE_HMAT AND OPENTURNS_HAVE_SPECTRA)
  ot_check_test (KarhunenLoeveP1Algorithm_hmat)
endif ()
if (OPENTURNS_HAVE_SPECTRA)
  ot_check_test (KarhunenLoeveP1Algorithm_spectra)
endif ()
ot_check_test (DesignProxy_std)
ot_check_test (LeastSquaresMethod_std)
ot_check_test (LeastSquaresMethod_weighted)
ot_check_test (KarhunenLoeveSVDAlgorithm_std)
ot_check_test (KarhunenLoeveLifting_std)
ot_check_test (KarhunenLoeveProjection_std)
ot_check_test (P1LagrangeInterpolation_std)
ot_check_test (SimplicialCubature_std IGNOREOUT)

# Analytical
ot_check_test (Analytical_std)
ot_check_test (AnalyticalResult_std)
ot_check_test (FORM_std)
ot_check_test (FORM_AbdoRackwitz)
ot_check_test (FORM_SQP)
ot_check_test (FORM_sensitivity)
ot_check_test (FORM_draw)
ot_check_test (SORM_std)
ot_check_test (StrongMaximumTest_std)
ot_check_test (StrongMaximumTest_tabulatedValues)
ot_check_test (StrongMaximumTest_other)

# Distribution
ot_check_test (Arcsine_std)
ot_check_test (ArcsineFactory_std)
ot_check_test (Bernoulli_std)
ot_check_test (BernoulliFactory_std)
ot_check_test (BernsteinCopulaFactory_std)
ot_check_test (Beta_std)
ot_check_test (BetaFactory_std)
ot_check_test (Binomial_std)
ot_check_test (BinomialFactory_std)
ot_check_test (BlockIndependentDistribution_std)
ot_check_test (Burr_std)
ot_check_test (BurrFactory_std)
ot_check_test (Chi_std)
ot_check_test (ChiFactory_std)
ot_check_test (ChiSquare_std)
ot_check_test (ChiSquareFactory_std)
ot_check_test (BlockIndependentCopula_std)
ot_check_test (JointDistribution_std)

=== python/src/CMakeLists.txt ===
#                                               -*- cmake -*-

add_definitions (${OPENTURNS_SWIG_DEFINITIONS})

set (CMAKE_SWIG_FLAGS "" CACHE STRING "SWIG flags for generating wrapper code")

# allows one to pass compile flags like -O1 to reduce memory usage
set (SWIG_COMPILE_FLAGS "" CACHE STRING "C++ compiler flags used for wrapper code")

# generate SWIG runtime header
execute_process (COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_CURRENT_BINARY_DIR}/openturns)
add_custom_command (OUTPUT  ${CMAKE_CURRENT_BINARY_DIR}/openturns/swigpyrun.h
                     COMMAND ${SWIG_EXECUTABLE}
                     ARGS -python -external-runtime ${CMAKE_CURRENT_BINARY_DIR}/openturns/swigpyrun.h
                     COMMENT "Swig runtime header")
add_custom_target (generate_swig_runtime DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/openturns/swigpyrun.h)
add_custom_target (generate_docstrings)
add_custom_target (pylib)

set (OPENTURNS_PYTHON_MODULES)
macro (ot_add_python_module MODULENAME SOURCEFILE)
  set_source_files_properties (${SOURCEFILE} PROPERTIES CPLUSPLUS ON)
  set_source_files_properties (${SOURCEFILE} PROPERTIES SWIG_MODULE_NAME ${MODULENAME})
  set_source_files_properties (${SOURCEFILE} PROPERTIES INCLUDE_DIRECTORIES "${INTERNAL_INCLUDE_DIRS};${CMAKE_CURRENT_SOURCE_DIR}")

  ot_install_swig_file (${SOURCEFILE})
  if (${ARGC} GREATER 2)
    set (SWIG_MODULE_${MODULENAME}_EXTRA_DEPS ${ARGN})
  endif ()
  list (APPEND SWIG_MODULE_${MODULENAME}_EXTRA_DEPS generate_docstrings openturns/PythonWrappingFunctions.hxx)

  set (swig_other_sources)
  set (docstring_sources)
  foreach (it ${ARGN})
    if (${it} MATCHES ".*\\.i$")
      ot_install_swig_file (${it})
    elseif (${it} MATCHES ".*_doc\\.i\\.in$")
      list (APPEND docstring_sources ${it})

      # for install target
      get_filename_component (DOCSTRING_FILE_BASENAME ${it} NAME_WE)
      list (APPEND SWIGFILES ${CMAKE_CURRENT_BINARY_DIR}/${DOCSTRING_FILE_BASENAME}.i)
    else ()
      list (APPEND swig_other_sources "${it}")
    endif ()
  endforeach ()
  
  # https://github.com/swig/swig/issues/1273
  option (SWIG_FORCE_DOUBLE_ESCAPE_BACKSLASH "Force double escaping of backslashes" OFF)
  mark_as_advanced (SWIG_FORCE_DOUBLE_ESCAPE_BACKSLASH)
  set (TIMES x1)
  if ((SWIG_VERSION VERSION_LESS 4) OR SWIG_FORCE_DOUBLE_ESCAPE_BACKSLASH)
    set (TIMES x2)
  endif ()

  # handle docstring generation
  add_custom_target (generate_${MODULENAME}_docstrings
                      COMMAND ${CMAKE_COMMAND} -DDOCSTRING_SOURCES="${docstring_sources}"
                      -DCURRENT_SOURCE_DIR=${CMAKE_CURRENT_SOURCE_DIR} -DTIMES=${TIMES}
                      -P ${PROJECT_SOURCE_DIR}/cmake/escape_backslash.cmake
                      DEPENDS ${docstring_sources})
  add_dependencies (generate_docstrings generate_${MODULENAME}_docstrings)  

  # swig_add_module is deprecated
  swig_add_library (${MODULENAME} LANGUAGE python SOURCES ${SOURCEFILE} ${swig_other_sources})

  add_dependencies (${MODULENAME} generate_swig_runtime)
  target_include_directories (${MODULENAME} PRIVATE ${INTERNAL_INCLUDE_DIRS} ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR} BEFORE)
  swig_link_libraries (${MODULENAME} OT)

  if (TARGET Python::Module)
    target_link_libraries (${MODULENAME} Python::Module)
  else ()
    target_include_directories (${MODULENAME} PRIVATE ${Python_INCLUDE_DIRS})
    target_link_libraries_with_dynamic_lookup (${MODULENAME} ${Python_LIBRARIES})
  endif ()

  set_target_properties (${MODULENAME} PROPERTIES COMPILE_FLAGS "${SWIG_COMPILE_FLAGS}")
  set_target_properties (${MODULENAME} PROPERTIES UNITY_BUILD OFF)

  install (FILES ${CMAKE_CURRENT_BINARY_DIR}/${MODULENAME}.py
           DESTINATION ${OPENTURNS_PYTHON_MODULE_PATH}/openturns)
  install (TARGETS ${MODULENAME}
            LIBRARY DESTINATION ${OPENTURNS_PYTHON_MODULE_PATH}/openturns)

  add_dependencies (pylib ${MODULENAME})
  list (APPEND OPENTURNS_PYTHON_MODULES ${MODULENAME})
endmacro ()

install (DIRECTORY openturns DESTINATION ${OPENTURNS_INCLUDE_PATH})

ot_add_python_module(common common_module.i
                      OTtypes.i
                      OTexceptions.i
                      TBB.i TBB_doc.i.in
                      Object.i Object_doc.i.in
                      PersistentObject.i PersistentObject_doc.i.in
                      Study.i Study_doc.i.in
                      StorageManager.i StorageManager_doc.i.in
                      XMLStorageManager.i XMLStorageManager_doc.i.in
                      XMLH5StorageManager.i XMLH5StorageManager_doc.i.in
                      Log.i Log_doc.i.in
                      TTY.i TTY_doc.i.in
                      Path.i Path_doc.i.in
                      Catalog.i
                      ResourceMap.i ResourceMap_doc.i.in
                      ComparisonOperatorImplementation.i
                      ComparisonOperator.i ComparisonOperator_doc.i.in
                      Equal.i Equal_doc.i.in
                      Greater.i Greater_doc.i.in
                      GreaterOrEqual.i GreaterOrEqual_doc.i.in
                      Less.i Less_doc.i.in
                      LessOrEqual.i LessOrEqual_doc.i.in
                      Cache.i
                      Pointer.i
                      InterfaceObject.i InterfaceObject_doc.i.in
                      TypedInterfaceObject.i
                      TypedCollectionInterfaceObject.i
                      BaseCommonTemplateDefs.i
                   )

if (LibXml2_FOUND)
  set_property (TARGET common APPEND PROPERTY SWIG_COMPILE_DEFINITIONS OPENTURNS_HAVE_LIBXML2=1)
endif ()

if (HDF5_FOUND)
  set_property (TARGET common APPEND PROPERTY SWIG_COMPILE_DEFINITIONS OPENTURNS_HAVE_HDF5=1)
endif ()

ot_add_python_module(typ typ_module.i
                      Collection.i Collection_doc.i.in
                      PersistentCollection.i
                      Description.i Description_doc.i.in
                      PlatformInfo.i PlatformInfo_doc.i.in
                      Point.i Point_doc.i.in
                      PointWithDescription.i PointWithDescription_doc.i.in
                      DomainImplementation.i DomainImplementation_doc.i.in
                      Interval.i Interval_doc.i.in
                      Indices.i Indices_doc.i.in
                      IndicesCollection.i IndicesCollection_doc.i.in
                      IndicesCollectionImplementation.i
                      MatrixImplementation.i
                      Matrix.i Matrix_doc.i.in
                      SquareMatrix.i SquareMatrix_doc.i.in
                      SymmetricMatrix.i SymmetricMatrix_doc.i.in
                      Tensor.i Tensor_doc.i.in
                      SymmetricTensor.i SymmetricTensor_doc.i.in
                      ComplexTensor.i ComplexTensor_doc.i.in
                      ComplexMatrix.i ComplexMatrix_doc.i.in
                      HermitianMatrix.i HermitianMatrix_doc.i.in
                      SquareComplexMatrix.i SquareComplexMatrix_doc.i.in
                      TriangularMatrix.i TriangularMatrix_doc.i.in
                      TriangularComplexMatrix.i TriangularComplexMatrix_doc.i.in
                      CovarianceMatrix.i CovarianceMatrix_doc.i.in
                      CorrelationMatrix.i CorrelationMatrix_doc.i.in
                      IdentityMatrix.i IdentityMatrix_doc.i.in
                      Sample.i Sample_doc.i.in
                      HistoryStrategyImplementation.i HistoryStrategyImplementation_doc.i.in
                      HistoryStrategy.i HistoryStrategy_doc.i.in
                      BaseTypCollection.i
                      BaseTypTemplateDefs.i
                   )

ot_add_python_module(statistics statistics_module.i
                      Compact.i Compact_doc.i.in
                      Full.i Full_doc.i.in
                      Last.i Last_doc.i.in
                      Null.i Null_doc.i.in
                      TestResult.i TestResult_doc.i.in
                      RandomGenerator.i RandomGenerator_doc.i.in
                      RandomGeneratorState.i RandomGeneratorState_doc.i.in
                      LowDiscrepancySequenceImplementation.i LowDiscrepancySequenceImplementation_doc.i.in
                      LowDiscrepancySequence.i LowDiscrepancySequence_doc.i.in
                      SobolSequence.i SobolSequence_doc.i.in
                      FaureSequence.i FaureSequence_doc.i.in
                      HaltonSequence.i HaltonSequence_doc.i.in
                      HaselgroveSequence.i HaselgroveSequence_doc.i.in
                      ReverseHaltonSequence.i ReverseHaltonSequence_doc.i.in
                      SphericalModel.i SphericalModel_doc.i.in
                      FilteringWindowsImplementation.i FilteringWindowsImplementation_doc.i.in
                      FilteringWindows.i FilteringWindows_doc.i.in
                      Hamming.i Hamming_doc.i.in
                      Hann.i Hann_doc.i.in
                      FFTImplementation.i FFTImplementation_doc.i.in
                      FFT.i FFT_doc.i.in
                      SpectralModelImplementation.i SpectralModelImplementation_doc.i.in
                      SpectralModel.i SpectralModel_doc.i.in
                      CovarianceModelImplementation.i CovarianceModelImplementation_doc.i.in
                      CovarianceModel.i CovarianceModel_doc.i.in
                      StationaryFunctionalCovarianceModel.i StationaryFunctionalCovarianceModel_doc.i.in
                      SpectralModelFactoryImplementation.i SpectralModelFactoryImplementation_doc.i.in
                      SpectralModelFactory.i SpectralModelFactory_doc.i.in
                      UserDefinedSpectralModel.i UserDefinedSpectralModel_doc.i.in
                      WelchFactory.i WelchFactory_doc.i.in
                      KroneckerCovarianceModel.i KroneckerCovarianceModel_doc.i.in
                      ExponentialModel.i ExponentialModel_doc.i.in
                      ExponentiallyDampedCosineModel.i ExponentiallyDampedCosineModel_doc.i.in
                      CauchyModel.i CauchyModel_doc.i.in
                      CovarianceModelFactoryImplementation.i CovarianceModelFactoryImplementation_doc.i.in
                      CovarianceModelFactory.i CovarianceModelFactory_doc.i.in
                      UserDefinedCovarianceModel.i UserDefinedCovarianceModel_doc.i.in
                      UserDefinedStationaryCovarianceModel.i UserDefinedStationaryCovarianceModel_doc.i.in
                      StationaryCovarianceModelFactory.i StationaryCovarianceModelFactory_doc.i.in
                      NonStationaryCovarianceModelFactory.i NonStationaryCovarianceModelFactory_doc.i.in
                      SquaredExponential.i SquaredExponential_doc.i.in
                      GeneralizedExponential.i GeneralizedExponential_doc.i.in
                      AbsoluteExponential.i AbsoluteExponential_doc.i.in
                      MaternModel.i MaternModel_doc.i.in
                      DiracCovarianceModel.i DiracCovarianceModel_doc.i.in
                      ProductCovarianceModel.i ProductCovarianceModel_doc.i.in
                      RankMCovarianceModel.i RankMCovarianceModel_doc.i.in
                      FractionalBrownianMotionModel.i FractionalBrownianMotionModel_doc.i.in
                      TensorizedCovarianceModel.i TensorizedCovarianceModel_doc.i.in
                      HMatrixParameters.i HMatrixParameters_doc.i.in
                      HMatrixFactory.i HMatrixFactory_doc.i.in
                      HMatrix.i HMatrix_doc.i.in
                      HMatrixImplementation.i HMatrixImplementation_doc.i.in
                      BaseStatisticsTemplateDefs.i
                      IsotropicCovarianceModel.i IsotropicCovarianceModel_doc.i.in
                      CorrelationAnalysis.i CorrelationAnalysis_doc.i.in
                      LatentVariableModel.i LatentVariableModel_doc.i.in
                   )

ot_add_python_module(iterative_statistics iterative_statistics_module.i

=== lib/src/Base/Common/CMakeLists.txt ===
#                                               -*- cmake -*-

# Register current directory files
ot_add_current_dir_to_include_dirs ()

ot_add_source_file (OSS.cxx)
ot_add_source_file (PlatformInfo.cxx)
ot_add_source_file (Object.cxx)
ot_add_source_file (PersistentObject.cxx)
ot_add_source_file (PersistentObjectFactory.cxx)
ot_add_source_file (IdFactory.cxx)
ot_add_source_file (Catalog.cxx)
ot_add_source_file (Exception.cxx)
ot_add_source_file (InterfaceObject.cxx)
ot_add_source_file (StorageManager.cxx)
ot_add_source_file (Os.cxx)
ot_add_source_file (Path.cxx)
ot_add_source_file (ComparisonOperator.cxx)
ot_add_source_file (ComparisonOperatorImplementation.cxx)
ot_add_source_file (OStream.cxx)
ot_add_source_file (Less.cxx)
ot_add_source_file (LessOrEqual.cxx)
ot_add_source_file (Equal.cxx)
ot_add_source_file (Greater.cxx)
ot_add_source_file (GreaterOrEqual.cxx)
ot_add_source_file (ResourceMap.cxx)
ot_add_source_file (Log.cxx)
ot_add_source_file (TTY.cxx)
ot_add_source_file (TBB.cxx)
ot_add_source_file (TBBImplementation.cxx)
ot_add_source_file (Study.cxx)

if (LIBXML2_FOUND)
  ot_add_source_file (XMLStorageManager.cxx)
  ot_add_source_file (XMLToolbox.cxx)
  if (HDF5_FOUND)
    ot_add_source_file (XMLH5StorageManager.cxx)
  endif ()
endif ()

ot_install_header_file (Greater.hxx)
ot_install_header_file (ResourceMap.hxx)
ot_install_header_file (ComparisonOperatorImplementation.hxx)
ot_install_header_file (OStream.hxx)
ot_install_header_file (StorageManager.hxx)
ot_install_header_file (OSS.hxx)
ot_install_header_file (Study.hxx)
ot_install_header_file (Less.hxx)
ot_install_header_file (PersistentObject.hxx)
ot_install_header_file (PlatformInfo.hxx)
ot_install_header_file (AtomicInt.hxx)
ot_install_header_file (MutexLock.hxx)
ot_install_header_file (Equal.hxx)
ot_install_header_file (Pointer.hxx)
ot_install_header_file (IdFactory.hxx)
ot_install_header_file (PersistentObjectFactory.hxx)
ot_install_header_file (ComparisonOperator.hxx)
ot_install_header_file (TypedInterfaceObject.hxx)
ot_install_header_file (InterfaceObject.hxx)
ot_install_header_file (OTCommon.hxx)
ot_install_header_file (Catalog.hxx)
ot_install_header_file (GreaterOrEqual.hxx)
ot_install_header_file (Log.hxx)
ot_install_header_file (TBB.hxx)
ot_install_header_file (TBBImplementation.hxx)
ot_install_header_file (TypedCollectionInterfaceObject.hxx)
ot_install_header_file (Os.hxx)
ot_install_header_file (Object.hxx)
ot_install_header_file (LessOrEqual.hxx)
ot_install_header_file (Exception.hxx)
ot_install_header_file (Path.hxx)
ot_install_header_file (TTY.hxx)

if (LIBXML2_FOUND)
  ot_install_header_file (XMLStorageManager.hxx)
  ot_install_header_file (XMLToolbox.hxx)
  if (HDF5_FOUND)
    ot_install_header_file (XMLH5StorageManager.hxx)
  endif ()
endif ()

=== lib/src/Base/Func/CMakeLists.txt ===
#                                               -*- cmake -*-

# Register current directory files
ot_add_current_dir_to_include_dirs ()

ot_add_source_file (AggregatedFunction.cxx)
ot_add_source_file (AggregatedGradient.cxx)
ot_add_source_file (AggregatedHessian.cxx)
ot_add_source_file (AggregatedEvaluation.cxx)
ot_add_source_file (BasisImplementation.cxx)
ot_add_source_file (Basis.cxx)
ot_add_source_file (BasisFactory.cxx)
ot_add_source_file (BasisSequenceImplementation.cxx)
ot_add_source_file (BasisSequence.cxx)
ot_add_source_file (BasisSequenceFactoryImplementation.cxx)
ot_add_source_file (BasisSequenceFactory.cxx)
ot_add_source_file (BoxCoxEvaluation.cxx)
ot_add_source_file (BoxCoxGradient.cxx)
ot_add_source_file (BoxCoxHessian.cxx)
ot_add_source_file (BoxCoxTransform.cxx)
ot_add_source_file (ConstantGradient.cxx)
ot_add_source_file (ConstantHessian.cxx)
ot_add_source_file (ComposedEvaluation.cxx)
ot_add_source_file (ComposedFunction.cxx)
ot_add_source_file (ComposedGradient.cxx)
ot_add_source_file (ComposedHessian.cxx)
ot_add_source_file (ConstantBasisFactory.cxx)
ot_add_source_file (DatabaseFunction.cxx)
ot_add_source_file (DatabaseEvaluation.cxx)
ot_add_source_file (DistanceToDomainEvaluation.cxx)
ot_add_source_file (DistanceToDomainFunction.cxx)
ot_add_source_file (DualLinearCombinationEvaluation.cxx)
ot_add_source_file (DualLinearCombinationFunction.cxx)
ot_add_source_file (DualLinearCombinationGradient.cxx)
ot_add_source_file (DualLinearCombinationHessian.cxx)
ot_add_source_file (EnumerateFunction.cxx)
ot_add_source_file (EnumerateFunctionImplementation.cxx)
ot_add_source_file (Evaluation.cxx)
ot_add_source_file (EvaluationImplementation.cxx)
ot_add_source_file (EvaluationProxy.cxx)
ot_add_source_file (ExpertMixture.cxx)
ot_add_source_file (FieldFunction.cxx)
ot_add_source_file (FieldFunctionImplementation.cxx)
ot_add_source_file (FieldToPointFunction.cxx)
ot_add_source_file (FieldToPointFunctionImplementation.cxx)
ot_add_source_file (FieldToFieldConnection.cxx)
ot_add_source_file (FieldToPointConnection.cxx)
ot_add_source_file (FiniteBasis.cxx)
ot_add_source_file (FourierSeries.cxx)
ot_add_source_file (Function.cxx)
ot_add_source_file (FunctionImplementation.cxx)
ot_add_source_file (GradientImplementation.cxx)
ot_add_source_file (Gradient.cxx)
ot_add_source_file (HaarWavelet.cxx)
ot_add_source_file (HessianImplementation.cxx)
ot_add_source_file (Hessian.cxx)
ot_add_source_file (HyperbolicAnisotropicEnumerateFunction.cxx)
ot_add_source_file (IdentityFunction.cxx)
ot_add_source_file (IdentityEvaluation.cxx)
ot_add_source_file (IndicatorEvaluation.cxx)
ot_add_source_file (IndicatorFunction.cxx)
ot_add_source_file (InverseBoxCoxEvaluation.cxx)
ot_add_source_file (InverseBoxCoxGradient.cxx)
ot_add_source_file (InverseBoxCoxHessian.cxx)
ot_add_source_file (InverseBoxCoxTransform.cxx)
ot_add_source_file (InverseTrendEvaluation.cxx)
ot_add_source_file (InverseTrendTransform.cxx)
ot_add_source_file (LinearBasisFactory.cxx)
ot_add_source_file (LinearCombinationEvaluation.cxx)
ot_add_source_file (LinearCombinationGradient.cxx)
ot_add_source_file (LinearCombinationHessian.cxx)
ot_add_source_file (LinearEvaluation.cxx)
ot_add_source_file (LinearFunction.cxx)
ot_add_source_file (LinearGradient.cxx)
ot_add_source_file (LinearCombinationFunction.cxx)
ot_add_source_file (LinearEnumerateFunction.cxx)
ot_add_source_file (LARS.cxx)
ot_add_source_file (MonomialFunction.cxx)
ot_add_source_file (MonomialFunctionFactory.cxx)
ot_add_source_file (MemoizeEvaluation.cxx)
ot_add_source_file (MemoizeFunction.cxx)
ot_add_source_file (NullHessian.cxx)
ot_add_source_file (MarginalEvaluation.cxx)
ot_add_source_file (MarginalGradient.cxx)
ot_add_source_file (MarginalHessian.cxx)
ot_add_source_file (NoEvaluation.cxx)
ot_add_source_file (NoGradient.cxx)
ot_add_source_file (NoHessian.cxx)
ot_add_source_file (NormInfEnumerateFunction.cxx)
ot_add_source_file (P1LagrangeEvaluation.cxx)
ot_add_source_file (P1LagrangeInterpolation.cxx)
ot_add_source_file (ParametricEvaluation.cxx)
ot_add_source_file (ParametricFunction.cxx)
ot_add_source_file (ParametricGradient.cxx)
ot_add_source_file (ParametricHessian.cxx)
ot_add_source_file (PiecewiseLinearEvaluation.cxx)
ot_add_source_file (PiecewiseHermiteEvaluation.cxx)
ot_add_source_file (PointToFieldFunction.cxx)
ot_add_source_file (PointToFieldFunctionImplementation.cxx)
ot_add_source_file (ParametricPointToFieldFunction.cxx)
ot_add_source_file (VertexValuePointToFieldFunction.cxx)
ot_add_source_file (PointToPointEvaluation.cxx)
ot_add_source_file (PointToFieldConnection.cxx)
ot_add_source_file (PointToPointConnection.cxx)
ot_add_source_file (ProductEvaluation.cxx)
ot_add_source_file (ProductFunction.cxx)
ot_add_source_file (ProductGradient.cxx)
ot_add_source_file (ProductHessian.cxx)
ot_add_source_file (ProductPolynomialEvaluation.cxx)
ot_add_source_file (ProductPolynomialHessian.cxx)
ot_add_source_file (ProductPolynomialGradient.cxx)
ot_add_source_file (ProductUniVariateFunctionEvaluation.cxx)
ot_add_source_file (ProductUniVariateFunctionGradient.cxx)
ot_add_source_file (ProductUniVariateFunctionHessian.cxx)
ot_add_source_file (QuadraticBasisFactory.cxx)
ot_add_source_file (QuadraticEvaluation.cxx)
ot_add_source_file (QuadraticFunction.cxx)
ot_add_source_file (SymbolicParserImplementation.cxx)
ot_add_source_file (SymbolicParser.cxx)
if (OPENTURNS_HAVE_MUPARSER)
ot_add_source_file (SymbolicParserMuParser.cxx)
endif ()
if (OPENTURNS_HAVE_EXPRTK)
ot_add_source_file (SymbolicParserExprTk.cxx)
endif ()
ot_add_source_file (SymbolicEvaluation.cxx)
ot_add_source_file (SymbolicFunction.cxx)
ot_add_source_file (SymbolicGradient.cxx)
ot_add_source_file (SymbolicHessian.cxx)
ot_add_source_file (TensorizedUniVariateFunctionFactory.cxx)
ot_add_source_file (TranslationFunction.cxx)
ot_add_source_file (TranslationEvaluation.cxx)
ot_add_source_file (TrendEvaluation.cxx)
ot_add_source_file (TrendTransform.cxx)
ot_add_source_file (UniVariateFunctionEvaluation.cxx)
ot_add_source_file (UniVariateFunctionFamily.cxx)
ot_add_source_file (UniVariateFunctionFactory.cxx)
ot_add_source_file (UniVariatePolynomialImplementation.cxx)
ot_add_source_file (UniVariatePolynomial.cxx)
ot_add_source_file (UniVariateFunctionImplementation.cxx)
ot_add_source_file (UniVariateFunction.cxx)
ot_add_source_file (ValueFunction.cxx)
ot_add_source_file (VertexValueFunction.cxx)

ot_install_header_file (AggregatedFunction.hxx)
ot_install_header_file (SymbolicParserImplementation.hxx)
ot_install_header_file (SymbolicParser.hxx)
# ot_install_header_file (SymbolicParserMuParser.hxx)  Internal header file
# ot_install_header_file (SymbolicParserExprTk.hxx)    Internal header file
ot_install_header_file (SymbolicEvaluation.hxx)
ot_install_header_file (SymbolicGradient.hxx)
ot_install_header_file (SymbolicHessian.hxx)
ot_install_header_file (ComposedFunction.hxx)
ot_install_header_file (DualLinearCombinationFunction.hxx)
ot_install_header_file (EnumerateFunction.hxx)
ot_install_header_file (EnumerateFunctionImplementation.hxx)
ot_install_header_file (LinearCombinationFunction.hxx)
ot_install_header_file (LinearEnumerateFunction.hxx)
ot_install_header_file (HyperbolicAnisotropicEnumerateFunction.hxx)
ot_install_header_file (NormInfEnumerateFunction.hxx)
ot_install_header_file (ParametricFunction.hxx)
ot_install_header_file (ProductPolynomialEvaluation.hxx)
ot_install_header_file (ProductPolynomialGradient.hxx)
ot_install_header_file (ProductPolynomialHessian.hxx)
ot_install_header_file (AggregatedEvaluation.hxx)
ot_install_header_file (AggregatedGradient.hxx)
ot_install_header_file (AggregatedHessian.hxx)
ot_install_header_file (BatchFailedException.hxx)
ot_install_header_file (PiecewiseLinearEvaluation.hxx)
ot_install_header_file (PiecewiseHermiteEvaluation.hxx)
ot_install_header_file (ConstantGradient.hxx)
ot_install_header_file (QuadraticEvaluation.hxx)
ot_install_header_file (NoGradient.hxx)
ot_install_header_file (ProductEvaluation.hxx)
ot_install_header_file (NoHessian.hxx)
ot_install_header_file (IndicatorEvaluation.hxx)
ot_install_header_file (DistanceToDomainEvaluation.hxx)
ot_install_header_file (MethodBoundEvaluation.hxx)
ot_install_header_file (ComposedHessian.hxx)
ot_install_header_file (OTFunc.hxx)
ot_install_header_file (HessianImplementation.hxx)
ot_install_header_file (Hessian.hxx)
ot_install_header_file (ProductFunction.hxx)
ot_install_header_file (TranslationEvaluation.hxx)
ot_install_header_file (LinearGradient.hxx)
ot_install_header_file (LinearEvaluation.hxx)
ot_install_header_file (IdentityEvaluation.hxx)
ot_install_header_file (NoEvaluation.hxx)
ot_install_header_file (ConstantHessian.hxx)
ot_install_header_file (TranslationFunction.hxx)
ot_install_header_file (LinearFunction.hxx)
ot_install_header_file (IdentityFunction.hxx)
ot_install_header_file (IndicatorFunction.hxx)
ot_install_header_file (DistanceToDomainFunction.hxx)
ot_install_header_file (QuadraticFunction.hxx)
ot_install_header_file (UniVariatePolynomial.hxx)
ot_install_header_file (UniVariatePolynomialImplementation.hxx)
ot_install_header_file (UniVariateFunction.hxx)
ot_install_header_file (UniVariateFunctionImplementation.hxx)
ot_install_header_file (FourierSeries.hxx)
ot_install_header_file (HaarWavelet.hxx)
ot_install_header_file (UniVariateFunctionEvaluation.hxx)
ot_install_header_file (ProductUniVariateFunctionEvaluation.hxx)
ot_install_header_file (ProductUniVariateFunctionHessian.hxx)
ot_install_header_file (ProductUniVariateFunctionGradient.hxx)
ot_install_header_file (ProductGradient.hxx)
ot_install_header_file (ComposedEvaluation.hxx)
ot_install_header_file (GradientImplementation.hxx)
ot_install_header_file (Gradient.hxx)
ot_install_header_file (EvaluationImplementation.hxx)
ot_install_header_file (Evaluation.hxx)
ot_install_header_file (ComposedGradient.hxx)
ot_install_header_file (DualLinearCombinationEvaluation.hxx)
ot_install_header_file (DualLinearCombinationGradient.hxx)
ot_install_header_file (DualLinearCombinationHessian.hxx)
ot_install_header_file (ExpertMixture.hxx)
ot_install_header_file (LinearCombinationEvaluation.hxx)
ot_install_header_file (LinearCombinationGradient.hxx)
ot_install_header_file (LinearCombinationHessian.hxx)
ot_install_header_file (FunctionImplementation.hxx)
ot_install_header_file (Function.hxx)
ot_install_header_file (FieldFunction.hxx)
ot_install_header_file (FieldFunctionImplementation.hxx)
ot_install_header_file (FieldToPointFunction.hxx)
ot_install_header_file (FieldToPointFunctionImplementation.hxx)
ot_install_header_file (PointToFieldFunction.hxx)
ot_install_header_file (PointToFieldFunctionImplementation.hxx)
ot_install_header_file (ParametricPointToFieldFunction.hxx)
ot_install_header_file (VertexValuePointToFieldFunction.hxx)
ot_install_header_file (PointToPointEvaluation.hxx)
ot_install_header_file (FieldToFieldConnection.hxx)
ot_install_header_file (FieldToPointConnection.hxx)
ot_install_header_file (PointToFieldConnection.hxx)
ot_install_header_file (PointToPointConnection.hxx)
ot_install_header_file (ValueFunction.hxx)
ot_install_header_file (SymbolicFunction.hxx)
ot_install_header_file (VertexValueFunction.hxx)
ot_install_header_file (ProductHessian.hxx)
ot_install_header_file (DatabaseFunction.hxx)
ot_install_header_file (DatabaseEvaluation.hxx)
ot_install_header_file (BasisImplementation.hxx)
ot_install_header_file (Basis.hxx)
ot_install_header_file (FiniteBasis.hxx)
ot_install_header_file (BasisSequenceImplementation.hxx)
ot_install_header_file (BasisSequence.hxx)
ot_install_header_file (BasisSequenceFactoryImplementation.hxx)
ot_install_header_file (BasisSequenceFactory.hxx)
ot_install_header_file (LARS.hxx)
ot_install_header_file (BoxCoxEvaluation.hxx)
ot_install_header_file (BoxCoxGradient.hxx)
ot_install_header_file (BoxCoxHessian.hxx)
ot_install_header_file (BoxCoxTransform.hxx)
ot_install_header_file (InverseBoxCoxEvaluation.hxx)
ot_install_header_file (InverseBoxCoxGradient.hxx)
ot_install_header_file (InverseBoxCoxHessian.hxx)

=== lib/src/Base/Optim/CMakeLists.txt ===
#                                               -*- cmake -*-

# Register current directory files
ot_add_current_dir_to_include_dirs ()

ot_add_source_file (AbdoRackwitz.cxx)
ot_add_source_file (algocobyla.c)
ot_add_source_file (Bonmin.cxx)
ot_add_source_file (Ceres.cxx)
ot_add_source_file (CMinpack.cxx)
ot_add_source_file (Cobyla.cxx)
if (OPENTURNS_HAVE_BONMIN)
  ot_add_source_file (BonminProblem.cxx)
endif ()
ot_add_source_file (Dlib.cxx)
if (dlib_FOUND)
  ot_add_source_file (DlibFunctions.cxx)
endif()
if (OPENTURNS_HAVE_IPOPT)
  ot_add_source_file (IpoptProblem.cxx)
endif()
ot_add_source_file (Ipopt.cxx)
ot_add_source_file (MultiStart.cxx)
ot_add_source_file (NearestPointChecker.cxx)
ot_add_source_file (NearestPointCheckerResult.cxx)
ot_add_source_file (NLopt.cxx)
ot_add_source_file (OptimizationProblem.cxx)
ot_add_source_file (OptimizationProblemImplementation.cxx)
ot_add_source_file (OptimizationAlgorithm.cxx)
ot_add_source_file (OptimizationAlgorithmImplementation.cxx)
ot_add_source_file (NearestPointProblem.cxx)
ot_add_source_file (LeastSquaresProblem.cxx)
ot_add_source_file (OptimizationResult.cxx)
ot_add_source_file (SQP.cxx)
ot_add_source_file (algotnc.c)
ot_add_source_file (TNC.cxx)
ot_add_source_file (Pagmo.cxx)

ot_install_header_file (OTOptim.hxx)
ot_install_header_file (AbdoRackwitz.hxx)
ot_install_header_file (Bonmin.hxx)
ot_install_header_file (Ceres.hxx)
ot_install_header_file (CMinpack.hxx)
ot_install_header_file (Cobyla.hxx)
ot_install_header_file (Dlib.hxx)
ot_install_header_file (Ipopt.hxx)
ot_install_header_file (MultiStart.hxx)
ot_install_header_file (NearestPointChecker.hxx)
ot_install_header_file (NearestPointCheckerResult.hxx)
ot_install_header_file (NLopt.hxx)
ot_install_header_file (OptimizationProblem.hxx)
ot_install_header_file (OptimizationProblemImplementation.hxx)
ot_install_header_file (NearestPointProblem.hxx)
ot_install_header_file (LeastSquaresProblem.hxx)
ot_install_header_file (OptimizationAlgorithm.hxx)
ot_install_header_file (OptimizationAlgorithmImplementation.hxx)
ot_install_header_file (OptimizationResult.hxx)
ot_install_header_file (SQP.hxx)
ot_install_header_file (TNC.hxx)
ot_install_header_file (Pagmo.hxx)

=== lib/src/Base/Stat/CMakeLists.txt ===
#                                               -*- cmake -*-

# Register current directory files
ot_add_current_dir_to_include_dirs ()

ot_add_source_file (Compact.cxx)
ot_add_source_file (CorrelationAnalysis.cxx)
ot_add_source_file (CorrelationMatrix.cxx)
ot_add_source_file (CovarianceMatrix.cxx)
ot_add_source_file (FaureSequence.cxx)
ot_add_source_file (Full.cxx)
ot_add_source_file (HaltonSequence.cxx)
ot_add_source_file (HaselgroveSequence.cxx)
ot_add_source_file (HistoryStrategy.cxx)
ot_add_source_file (HistoryStrategyImplementation.cxx)
ot_add_source_file (HMatrixFactory.cxx)
ot_add_source_file (HMatrix.cxx)
ot_add_source_file (HMatrixImplementation.cxx)
ot_add_source_file (KroneckerCovarianceModel.cxx)
ot_add_source_file (Last.cxx)
ot_add_source_file (LowDiscrepancySequence.cxx)
ot_add_source_file (LowDiscrepancySequenceImplementation.cxx)
ot_add_source_file (Null.cxx)
ot_add_source_file (Sample.cxx)
ot_add_source_file (SampleImplementation.cxx)
ot_add_source_file (SamplePartition.cxx)
ot_add_source_file (ProcessSample.cxx)
ot_add_source_file (ProcessSampleImplementation.cxx)
ot_add_source_file (RandomGenerator.cxx)
ot_add_source_file (RandomGeneratorState.cxx)
ot_add_source_file (ReverseHaltonSequence.cxx)
ot_add_source_file (SobolSequence.cxx)
ot_add_source_file (TestResult.cxx)
ot_add_source_file (Field.cxx)
ot_add_source_file (FieldImplementation.cxx)
ot_add_source_file (TimeSeries.cxx)
ot_add_source_file (dsfmt.cxx)
ot_add_source_file (FilteringWindowsImplementation.cxx)
ot_add_source_file (FilteringWindows.cxx)
ot_add_source_file (Hamming.cxx)
ot_add_source_file (Hann.cxx)
ot_add_source_file (CovarianceModelImplementation.cxx)
ot_add_source_file (SpectralModelImplementation.cxx)
ot_add_source_file (SpectralModel.cxx)
ot_add_source_file (CovarianceModel.cxx)
ot_add_source_file (SpectralModelFactoryImplementation.cxx)
ot_add_source_file (SpectralModelFactory.cxx)
ot_add_source_file (UserDefinedSpectralModel.cxx)
ot_add_source_file (WelchFactory.cxx)
ot_add_source_file (ExponentialModel.cxx)
ot_add_source_file (ExponentiallyDampedCosineModel.cxx)
ot_add_source_file (SphericalModel.cxx)
ot_add_source_file (CauchyModel.cxx)
ot_add_source_file (SquaredExponential.cxx)
ot_add_source_file (GeneralizedExponential.cxx)
ot_add_source_file (AbsoluteExponential.cxx)
ot_add_source_file (StationaryFunctionalCovarianceModel.cxx)
ot_add_source_file (FractionalBrownianMotionModel.cxx)
ot_add_source_file (MaternModel.cxx)
ot_add_source_file (DiracCovarianceModel.cxx)
ot_add_source_file (HMatrixParameters.cxx)
ot_add_source_file (ProductCovarianceModel.cxx)
ot_add_source_file (RankMCovarianceModel.cxx)
ot_add_source_file (TensorizedCovarianceModel.cxx)
ot_add_source_file (CovarianceModelFactoryImplementation.cxx)
ot_add_source_file (CovarianceModelFactory.cxx)
ot_add_source_file (UserDefinedCovarianceModel.cxx)
ot_add_source_file (NonStationaryCovarianceModelFactory.cxx)
ot_add_source_file (UserDefinedStationaryCovarianceModel.cxx)
ot_add_source_file (StationaryCovarianceModelFactory.cxx)
ot_add_source_file (kendall.c)
ot_add_source_file (IsotropicCovarianceModel.cxx)
ot_add_source_file (LatentVariableModel.cxx)

ot_install_header_file (HistoryStrategyImplementation.hxx)
ot_install_header_file (SobolSequence.hxx)
ot_install_header_file (CovarianceMatrix.hxx)
ot_install_header_file (TestResult.hxx)
ot_install_header_file (FaureSequence.hxx)
ot_install_header_file (HaltonSequence.hxx)
ot_install_header_file (HaselgroveSequence.hxx)
ot_install_header_file (ReverseHaltonSequence.hxx)
ot_install_header_file (CorrelationMatrix.hxx)
ot_install_header_file (HMatrixFactory.hxx)
ot_install_header_file (HMatrix.hxx)
ot_install_header_file (HMatrixImplementation.hxx)
ot_install_header_file (KroneckerCovarianceModel.hxx)
ot_install_header_file (Last.hxx)
ot_install_header_file (RandomGenerator.hxx)
ot_install_header_file (RandomGeneratorState.hxx)
ot_install_header_file (csv_parser_state.hxx)
ot_install_header_file (HistoryStrategy.hxx)
ot_install_header_file (CorrelationAnalysis.hxx)
ot_install_header_file (LowDiscrepancySequence.hxx)
ot_install_header_file (Full.hxx)
ot_install_header_file (SampleImplementation.hxx)
ot_install_header_file (Sample.hxx)
ot_install_header_file (SamplePartition.hxx)
ot_install_header_file (ProcessSample.hxx)
ot_install_header_file (ProcessSampleImplementation.hxx)
ot_install_header_file (OTStat.hxx)
ot_install_header_file (Compact.hxx)
ot_install_header_file (LowDiscrepancySequenceImplementation.hxx)
ot_install_header_file (Null.hxx)
ot_install_header_file (Field.hxx)
ot_install_header_file (FieldImplementation.hxx)
ot_install_header_file (TimeSeries.hxx)
ot_install_header_file (FilteringWindowsImplementation.hxx)
ot_install_header_file (FilteringWindows.hxx)
ot_install_header_file (Hamming.hxx)
ot_install_header_file (Hann.hxx)
ot_install_header_file (CovarianceModelImplementation.hxx)
ot_install_header_file (SpectralModelImplementation.hxx)
ot_install_header_file (SpectralModel.hxx)
ot_install_header_file (CovarianceModel.hxx)
ot_install_header_file (SpectralModelFactoryImplementation.hxx)
ot_install_header_file (SpectralModelFactory.hxx)
ot_install_header_file (UserDefinedSpectralModel.hxx)
ot_install_header_file (WelchFactory.hxx)
ot_install_header_file (ExponentialModel.hxx)
ot_install_header_file (ExponentiallyDampedCosineModel.hxx)
ot_install_header_file (SphericalModel.hxx)
ot_install_header_file (CauchyModel.hxx)
ot_install_header_file (CovarianceModelFactoryImplementation.hxx)
ot_install_header_file (CovarianceModelFactory.hxx)
ot_install_header_file (UserDefinedCovarianceModel.hxx)
ot_install_header_file (NonStationaryCovarianceModelFactory.hxx)
ot_install_header_file (UserDefinedStationaryCovarianceModel.hxx)
ot_install_header_file (StationaryCovarianceModelFactory.hxx)
ot_install_header_file (SquaredExponential.hxx)
ot_install_header_file (GeneralizedExponential.hxx)
ot_install_header_file (AbsoluteExponential.hxx)
ot_install_header_file (StationaryFunctionalCovarianceModel.hxx)
ot_install_header_file (FractionalBrownianMotionModel.hxx)
ot_install_header_file (MaternModel.hxx)
ot_install_header_file (DiracCovarianceModel.hxx)
ot_install_header_file (HMatrixParameters.hxx)
ot_install_header_file (ProductCovarianceModel.hxx)
ot_install_header_file (RankMCovarianceModel.hxx)
ot_install_header_file (TensorizedCovarianceModel.hxx)
ot_install_header_file (IsotropicCovarianceModel.hxx)
ot_install_header_file (LatentVariableModel.hxx)

# Build on the fly source files
if (BISON_FOUND AND FLEX_FOUND)
  ot_add_build_dir_to_include_dirs (${CMAKE_CURRENT_BINARY_DIR})
  set (BISON_FLAGS "-Wno-deprecated" CACHE STRING "bison flags")
  separate_arguments(BISON_FLAGS)
  add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/csv_parser.cc ${CMAKE_CURRENT_BINARY_DIR}/csv_parser.hh
                      MAIN_DEPENDENCY ${CMAKE_CURRENT_SOURCE_DIR}/csv_parser.yy
                      COMMAND ${BISON_EXECUTABLE}
                      ARGS    ${BISON_FLAGS}
                              -o ${CMAKE_CURRENT_BINARY_DIR}/csv_parser.cc
                                 ${CMAKE_CURRENT_SOURCE_DIR}/csv_parser.yy
                      COMMENT "CSV parser generation"
                   )
  ot_add_built_source_file (${CMAKE_CURRENT_BINARY_DIR}/csv_parser.cc)
  add_custom_target (generate_csv_parser DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/csv_parser.cc)

  add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/csv_lexer.cc ${CMAKE_CURRENT_BINARY_DIR}/csv_lexer.h
                      MAIN_DEPENDENCY ${CMAKE_CURRENT_SOURCE_DIR}/csv_lexer.ll
                      COMMAND ${FLEX_EXECUTABLE}
                      ARGS    --nounistd -o ${CMAKE_CURRENT_BINARY_DIR}/csv_lexer.cc
                              --header-file=${CMAKE_CURRENT_BINARY_DIR}/csv_lexer.h
                              ${CMAKE_CURRENT_SOURCE_DIR}/csv_lexer.ll
                      COMMENT "CSV lexer generation"
                   )
  ot_add_built_source_file (${CMAKE_CURRENT_BINARY_DIR}/csv_lexer.cc)
  add_custom_target (generate_csv_lexer DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/csv_lexer.cc)
endif ()

=== lib/src/Base/Type/CMakeLists.txt ===
#                                               -*- cmake -*-

# Register current directory files
ot_add_current_dir_to_include_dirs ()

ot_add_source_file (BipartiteGraph.cxx)
ot_add_source_file (Description.cxx)
ot_add_source_file (Point.cxx)
ot_add_source_file (PointWithDescription.cxx)
ot_add_source_file (MatrixImplementation.cxx)
ot_add_source_file (Matrix.cxx)
ot_add_source_file (Tensor.cxx)
ot_add_source_file (SymmetricTensor.cxx)
ot_add_source_file (IdentityMatrix.cxx)
ot_add_source_file (SquareMatrix.cxx)
ot_add_source_file (TriangularMatrix.cxx)
ot_add_source_file (SymmetricMatrix.cxx)
ot_add_source_file (TensorImplementation.cxx)
ot_add_source_file (ComplexTensorImplementation.cxx)
ot_add_source_file (ComplexTensor.cxx)
ot_add_source_file (Indices.cxx)
ot_add_source_file (IndicesCollectionImplementation.cxx)
ot_add_source_file (IndicesCollection.cxx)
ot_add_source_file (ComplexMatrixImplementation.cxx)
ot_add_source_file (ComplexMatrix.cxx)
ot_add_source_file (HermitianMatrix.cxx)
ot_add_source_file (SquareComplexMatrix.cxx)
ot_add_source_file (TriangularComplexMatrix.cxx)
ot_add_source_file (SparseMatrix.cxx)

ot_install_header_file (BipartiteGraph.hxx)
ot_install_header_file (PointWithDescription.hxx)
ot_install_header_file (OTType.hxx)
ot_install_header_file (PersistentCollection.hxx)
ot_install_header_file (Point.hxx)
ot_install_header_file (Collection.hxx)
ot_install_header_file (TensorImplementation.hxx)
ot_install_header_file (ComplexTensorImplementation.hxx)
ot_install_header_file (ComplexTensor.hxx)
ot_install_header_file (SymmetricMatrix.hxx)
ot_install_header_file (SymmetricTensor.hxx)
ot_install_header_file (Indices.hxx)
ot_install_header_file (IndicesCollectionImplementation.hxx)
ot_install_header_file (IndicesCollection.hxx)
ot_install_header_file (Cache.hxx)
ot_install_header_file (IdentityMatrix.hxx)
ot_install_header_file (Tensor.hxx)
ot_install_header_file (MatrixImplementation.hxx)
ot_install_header_file (Description.hxx)
ot_install_header_file (Matrix.hxx)
ot_install_header_file (SquareMatrix.hxx)
ot_install_header_file (ComplexMatrixImplementation.hxx)
ot_install_header_file (ComplexMatrix.hxx)
ot_install_header_file (HermitianMatrix.hxx)
ot_install_header_file (SquareComplexMatrix.hxx)
ot_install_header_file (TriangularMatrix.hxx)
ot_install_header_file (TriangularComplexMatrix.hxx)
ot_install_header_file (SparseMatrix.hxx)

=== lib/src/Uncertainty/Algorithm/Sensitivity/CMakeLists.txt ===
#                                               -*- cmake -*-
#
#  CMakeLists.txt
#
#  Copyright 2005-2024 Airbus-EDF-IMACS-ONERA-Phimeca
#
#  This library is free software: you can redistribute it and/or modify
#  it under the terms of the GNU Lesser General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public License
#  along with this library.  If not, see <http://www.gnu.org/licenses/>.
#
#

# Register current directory files
ot_add_current_dir_to_include_dirs ()

ot_add_source_file (ANCOVA.cxx)
ot_add_source_file (FAST.cxx)
ot_add_source_file (JansenSensitivityAlgorithm.cxx)
ot_add_source_file (MartinezSensitivityAlgorithm.cxx)
ot_add_source_file (MauntzKucherenkoSensitivityAlgorithm.cxx)
ot_add_source_file (RankSobolSensitivityAlgorithm.cxx)
ot_add_source_file (SaltelliSensitivityAlgorithm.cxx)
ot_add_source_file (SobolIndicesAlgorithm.cxx)
ot_add_source_file (SobolIndicesAlgorithmImplementation.cxx)
ot_add_source_file (SobolIndicesExperiment.cxx)
ot_add_source_file (HSICStat.cxx)
ot_add_source_file (HSICStatImplementation.cxx)
ot_add_source_file (HSICUStat.cxx)
ot_add_source_file (HSICVStat.cxx)
ot_add_source_file (HSICEstimator.cxx)
ot_add_source_file (HSICEstimatorImplementation.cxx)
ot_add_source_file (HSICEstimatorConditionalSensitivity.cxx)
ot_add_source_file (HSICEstimatorGlobalSensitivity.cxx)
ot_add_source_file (HSICEstimatorTargetSensitivity.cxx)


ot_install_header_file (OTSensitivity.hxx)
ot_install_header_file (ANCOVA.hxx)
ot_install_header_file (FAST.hxx)
ot_install_header_file (JansenSensitivityAlgorithm.hxx)
ot_install_header_file (MartinezSensitivityAlgorithm.hxx)
ot_install_header_file (MauntzKucherenkoSensitivityAlgorithm.hxx)
ot_install_header_file (RankSobolSensitivityAlgorithm.hxx)
ot_install_header_file (SaltelliSensitivityAlgorithm.hxx)
ot_install_header_file (SobolIndicesAlgorithm.hxx)
ot_install_header_file (SobolIndicesAlgorithmImplementation.hxx)
ot_install_header_file (SobolIndicesExperiment.hxx)
ot_install_header_file (HSICStat.hxx)
ot_install_header_file (HSICStatImplementation.hxx)
ot_install_header_file (HSICUStat.hxx)
ot_install_header_file (HSICVStat.hxx)
ot_install_header_file (HSICEstimator.hxx)
ot_install_header_file (HSICEstimatorImplementation.hxx)
ot_install_header_file (HSICEstimatorConditionalSensitivity.hxx)
ot_install_header_file (HSICEstimatorGlobalSensitivity.hxx)
ot_install_header_file (HSICEstimatorTargetSensitivity.hxx)

=== lib/src/Uncertainty/Algorithm/WeightedExperiments/CMakeLists.txt ===
#                                               -*- cmake -*-
#
#  CMakeLists.txt
#
#  Copyright 2005-2024 Airbus-EDF-IMACS-ONERA-Phimeca
#
#  This library is free software: you can redistribute it and/or modify
#  it under the terms of the GNU Lesser General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public License
#  along with this library.  If not, see <http://www.gnu.org/licenses/>.
#
#

# Register current directory files
ot_add_current_dir_to_include_dirs ()

ot_add_source_file (WeightedExperimentImplementation.cxx)
ot_add_source_file (WeightedExperiment.cxx)
ot_add_source_file (FixedExperiment.cxx)
ot_add_source_file (GaussProductExperiment.cxx)
ot_add_source_file (BootstrapExperiment.cxx)
ot_add_source_file (MonteCarloExperiment.cxx)
ot_add_source_file (ImportanceSamplingExperiment.cxx)
ot_add_source_file (ExperimentIntegration.cxx)
ot_add_source_file (LHSResult.cxx)
ot_add_source_file (SimulatedAnnealingLHS.cxx)
ot_add_source_file (MonteCarloLHS.cxx)
ot_add_source_file (OptimalLHSExperiment.cxx)
ot_add_source_file (SpaceFillingPhiP.cxx)
ot_add_source_file (SpaceFillingMinDist.cxx)
ot_add_source_file (SpaceFillingC2.cxx)
ot_add_source_file (SpaceFillingImplementation.cxx)
ot_add_source_file (SpaceFilling.cxx)
ot_add_source_file (LinearProfile.cxx)
ot_add_source_file (GeometricProfile.cxx)
ot_add_source_file (TemperatureProfileImplementation.cxx)
ot_add_source_file (TemperatureProfile.cxx)
ot_add_source_file (LHSExperiment.cxx)
ot_add_source_file (LowDiscrepancyExperiment.cxx)
ot_add_source_file (SplitterImplementation.cxx)
ot_add_source_file (KFoldSplitter.cxx)
ot_add_source_file (LeaveOneOutSplitter.cxx)
ot_add_source_file (TensorProductExperiment.cxx)
ot_add_source_file (SmolyakExperiment.cxx)

ot_install_header_file (OTWeightedExperiments.hxx)
ot_install_header_file (WeightedExperimentImplementation.hxx)
ot_install_header_file (WeightedExperiment.hxx)
ot_install_header_file (FixedExperiment.hxx)
ot_install_header_file (GaussProductExperiment.hxx)
ot_install_header_file (BootstrapExperiment.hxx)
ot_install_header_file (MonteCarloExperiment.hxx)
ot_install_header_file (ImportanceSamplingExperiment.hxx)
ot_install_header_file (ExperimentIntegration.hxx)
ot_install_header_file (LHSResult.hxx)
ot_install_header_file (SimulatedAnnealingLHS.hxx)
ot_install_header_file (MonteCarloLHS.hxx)
ot_install_header_file (OptimalLHSExperiment.hxx)
ot_install_header_file (SpaceFillingPhiP.hxx)
ot_install_header_file (SpaceFillingMinDist.hxx)
ot_install_header_file (SpaceFillingC2.hxx)
ot_install_header_file (SpaceFillingImplementation.hxx)
ot_install_header_file (SpaceFilling.hxx)
ot_install_header_file (LinearProfile.hxx)
ot_install_header_file (GeometricProfile.hxx)
ot_install_header_file (TemperatureProfileImplementation.hxx)
ot_install_header_file (TemperatureProfile.hxx)
ot_install_header_file (LHSExperiment.hxx)
ot_install_header_file (LowDiscrepancyExperiment.hxx)
ot_install_header_file (SplitterImplementation.hxx)
ot_install_header_file (KFoldSplitter.hxx)
ot_install_header_file (LeaveOneOutSplitter.hxx)
ot_install_header_file (TensorProductExperiment.hxx)
ot_install_header_file (SmolyakExperiment.hxx)

=== debian/changelog ===
openturns (1.24-4) unstable; urgency=medium

  * Deactivating the tests that randomly hang on amd64 on buildds
    (Closes: #1093144)

 -- Pierre Gruet <pgt@debian.org>  Wed, 15 Jan 2025 17:37:26 +0100

openturns (1.24-3) unstable; urgency=medium

  * Upload to unstable to start the library transition
  * Checking the package builds against swig 4.3.0 (Closes: #1091444)

 -- Pierre Gruet <pgt@debian.org>  Tue, 14 Jan 2025 21:35:52 +0100

openturns (1.24-2) experimental; urgency=medium

  * Adding a small tolerance to Pagmo Python test

 -- Pierre Gruet <pgt@debian.org>  Wed, 18 Dec 2024 10:08:51 +0100

openturns (1.24-1) experimental; urgency=medium

  * New upstream version 1.24
  * Removing all patches, which have been upstreamed
  * Bumping SOVERSION to 0.25, new binary package
  * Updating copyright date and information in d/copyright
  * Updating install paths of Python files
  * Updating the Ishigami Chaos autopkgtest to comply with latest upstream
    version

 -- Pierre Gruet <pgt@debian.org>  Sat, 14 Dec 2024 23:30:30 +0100

=== debian/control ===
Source: openturns
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Pierre Gruet <pgt@debian.org>
Build-Depends: debhelper-compat (= 13),
               bison,
               cmake,
               coinor-libbonmin-dev,
               coinor-libipopt-dev,
               dh-python,
               gfortran,
               flex,
               libblas-dev,
               libboost-math-dev,
               libceres-dev,
               libcminpack-dev,
               libdlib-dev (>= 19.24.4+dfsg),
               libhdf5-dev,
               liblapack-dev,
               libmpc-dev,
               libmpfr-dev,
               libmuparser-dev,
               libnanoflann-dev,
               libnlopt-cxx-dev,
               libpagmo-dev,
               libprimesieve-dev,
               libspectra-dev,
               libtbb-dev,
               libxml2-dev,
               python3-dev,
               swig
Standards-Version: 4.7.0
Homepage: https://openturns.github.io/www/
Vcs-Browser: https://salsa.debian.org/science-team/openturns
Vcs-Git: https://salsa.debian.org/science-team/openturns.git
Rules-Requires-Root: no

Package: libopenturns0.25
Section: libs
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         openturns-common (= ${source:Version})
Suggests: python3-openturns
Description: dynamic libraries for OpenTURNS
 OpenTURNS is a powerful and generic tool to treat and quantify
 uncertainties in numerical simulations in design, optimization and
 control. It allows both sensitivity and reliability analysis studies:
  * define the outputs of interest and decision criteria;
  * quantify and model the source of uncertainties;
  * propagate uncertainties and/or analyse sensitivity
  * rank the sources of uncertainty
 .
 Targeted users are all engineers who want to introduce the
 probabilistic dimension in their so far deterministic studies.
 .
 This package provides the dynamic libraries.

Package: libopenturns-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends},
         libopenturns0.25 (= ${binary:Version}),
         libceres-dev
Description: headers and development libraries for OpenTURNS
 OpenTURNS is a powerful and generic tool to treat and quantify
 uncertainties in numerical simulations in design, optimization and
 control. It allows both sensitivity and reliability analysis studies:
  * defining the outputs of interest and decision criterion;
  * quantify and model the source of uncertainties;
  * propagate uncertainties and/or analyse sensitivity and
  * rank the sources of uncertainty
 .
 Targeted users are all engineers who want to introduce the
 probabilistic dimension in their so far deterministic studies.
 .
 This package contains development files needed to build OpenTURNS applications.

Package: openturns-common
Architecture: all
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: generic tool to treat and quantify uncertainties (common files)
 OpenTURNS is a powerful and generic tool to treat and quantify
 uncertainties in numerical simulations in design, optimization and
 control. It allows both sensitivity and reliability analysis studies:
  * defining the outputs of interest and decision criterion;
  * quantify and model the source of uncertainties;
  * propagate uncertainties and/or analyse sensitivity and
  * rank the sources of uncertainty
 .
 Targeted users are all engineers who want to introduce the
 probabilistic dimension in their so far deterministic studies.
 .
 This package contains the configuration file for the versioned library
 package.

Package: python3-openturns
Section: python
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libopenturns0.25 (= ${binary:Version}),
         ${python3:Depends}
Provides: ${python3:Provides}
Suggests: python3-matplotlib,
          python3-scipy
Description: Python3 front-end of OpenTURNS (aka TUI)
 OpenTURNS is a powerful and generic tool to treat and quantify
 uncertainties in numerical simulations in design, optimization and
 control. It allows both sensitivity and reliability analysis studies:
  * defining the outputs of interest and decision criterion;
  * quantify and model the source of uncertainties;
  * propagate uncertainties and/or analyse sensitivity and
  * rank the sources of uncertainty
 .
 Targeted users are all engineers who want to introduce the
 probabilistic dimension in their so far deterministic studies.
 .
 This package provides the Python3 bindings to the library.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/architecture.mk

# Getting the number of jobs for the Debian build to transmit it to CMake.
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	test_makeflags = -j$(NUMJOBS)
endif

# On riscv64, deactivating Dlib-related tests (seems to be a bug in Dlib)
ifeq ($(shell dpkg --print-architecture),riscv64)
    test_discardflags := -E \\\"Dlib_.*|OptimizationAlgorithm_std\\\"
endif

# On loong64, deactivating Dlib tests (seems to be a bug in Dlib)
ifeq ($(shell dpkg --print-architecture),loong64)
    test_discardflags := -E \\\"Dlib_.*|OptimizationAlgorithm_std\\\"
endif

# On armel, deactivating EfficientGlobalOptimization test (can be quite sensitive)
ifeq ($(shell dpkg --print-architecture),armel)
    test_discardflags := -E \\\"EfficientGlobalOptimization_std\\\"
endif

BUILD_DATE = $(shell date --utc --date="@$(SOURCE_DATE_EPOCH)" "+%a, %d %b %Y %H:%M:%S %z")

%:
	dh $@ --buildsystem=cmake --with python3

override_dh_auto_configure:
	dh_auto_configure -Bbuilddir -- \
	        -DUSE_TBB:BOOL=ON \
            -Dot_configure_date:STRING='$(BUILD_DATE)' \
            -DUSE_SPHINX:BOOL=OFF \
            -DCMAKE_SKIP_INSTALL_RPATH:BOOL=ON \
            -DCMAKE_INSTALL_PREFIX:PATH=/usr \
            -DCMAKE_INSTALL_LIBDIR:PATH="/usr/lib/$(DEB_HOST_MULTIARCH)" \
            -DOPENTURNS_PYTHON_MODULE_PATH=lib/python3/dist-packages \
            -DINSTALL_DESTDIR:PATH=$(CURDIR)/debian/tmp \
	        -DCMAKE_UNITY_BUILD=ON -DCMAKE_UNITY_BUILD_BATCH_SIZE=32 \
            -DSWIG_COMPILE_FLAGS:STRING='-O1'

override_dh_auto_build:
	$(MAKE) $(test_makeflags) -C builddir/lib
	$(MAKE) -j1 -C builddir/python
	$(MAKE) $(test_makeflags) -C builddir

override_dh_auto_install:
	dh_auto_install -Bbuilddir
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	eval "LD_LIBRARY_PATH=$${LD_LIBRARY_PATH:+$${LD_LIBRARY_PATH}:}$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH) \
	  CTEST_OUTPUT_ON_FAILURE=1 \
	  $(MAKE) $(test_makeflags) -C builddir test ARGS=\"$(test_makeflags) $(test_discardflags) -R pyinstallcheck\""
endif

override_dh_auto_test:
	# 'make test' does not build binary tests
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	$(MAKE) $(test_makeflags) -C builddir tests
	eval "CTEST_OUTPUT_ON_FAILURE=1 \
	  $(MAKE) -C builddir test ARGS=\"$(test_makeflags) $(test_discardflags) -R cppcheck\""
endif

override_dh_clean:
	rm -rf builddir
	dh_clean

=== debian/tests/control ===
Tests: cxx-Ceres-test, cxx-SimulatedAnnealingLHS-test
Depends: build-essential, libopenturns-dev
Architecture: !i386
Restrictions: allow-stderr

Test-Command: python3 debian/tests/plot_central_tendency.py
Depends: python3-matplotlib, python3-numpy, python3-openturns
Architecture: !i386
Restrictions: allow-stderr

Test-Command: python3 debian/tests/plot_chaos_ishigami.py
Depends: python3-matplotlib, python3-numpy, python3-openturns
Architecture: !i386
Restrictions: allow-stderr
